> ## Documentation Index
> Fetch the complete documentation index at: https://docs.withorb.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Issue invoice

> This endpoint allows an eligible invoice to be issued manually. This is only possible with invoices where status is `draft`,
`will_auto_issue` is false, and an `eligible_to_issue_at` is a time in the past. Issuing an invoice could possibly trigger
side effects, some of which could be customer-visible (e.g. sending emails, auto-collecting payment,
syncing the invoice to external providers, etc).



## OpenAPI

````yaml /api-reference/orb-openapi.json post /invoices/{invoice_id}/issue
openapi: 3.1.0
info:
  title: API Reference
  description: >-
    Orb's API is built with the following principles in mind:


    1. **Predictable developer experience**: Where applicable, the Orb API uses
    industry-standard patterns such as

    cursor-based pagination and standardized error output. To help with
    debugging in critical API

    actions, the API always strives to provide detailed and actionable error
    messages. Aliases

    such as external customer IDs aid in fast integration times.

    2. **Reliably real time**: Orb's event-based APIs, such as event ingestion
    are designed to handle extremely high

    throughput and scale with concurrent load. Orb also provides a real-time
    event-level credits

    ledger and a highly performant webhooks architecture.

    3. **Flexibility at the forefront**: Features like timezone localization and
    the ability to amend historical usage

    show the flexible nature of the platform.


    You can download the latest OpenAPI spec
    [here](https://api.withorb.com/spec.json) - pass `?version=3.0` for an

    OpenAPI 3.0-compatible spec.
  contact:
    name: Orb, Inc.
    url: https://www.withorb.com/
    email: team@withorb.com
  version: '1.0'
servers:
  - url: https://api.withorb.com/v1
    description: Production server
security:
  - APIKeyAuth: []
tags:
  - name: Alert
    description: >-
      [Alerts within Orb](/product-catalog/configuring-alerts) monitor spending,

      usage, or credit balance and trigger webhooks when a threshold is
      exceeded.


      Alerts created through the API can be scoped to either customers or
      subscriptions.
  - name: Availability
  - name: Coupon
    description: >-
      A coupon represents a reusable discount configuration that can be applied
      either as a fixed or percentage amount to an invoice or subscription.
      Coupons are activated using a redemption code, which applies the discount
      to a subscription or invoice. The duration of a coupon determines how long
      it remains available for use by end users.
  - name: Credit
    description: >-
      The [Credit Ledger Entry resource](/product-catalog/prepurchase) models
      prepaid credits within Orb.
  - name: Credit note
    description: >-
      The [Credit Note](/invoicing/credit-notes) resource represents a credit
      that has been applied to a

      particular invoice.
  - name: Customer
    description: >-
      A customer is a buyer of your products, and the other party to the billing
      relationship.


      In Orb, customers are assigned system generated identifiers automatically,
      but it's often desirable to have these

      match existing identifiers in your system. To avoid having to denormalize
      Orb ID information, you can pass in an

      `external_customer_id` with your own identifier. See

      [Customer ID Aliases](/events-and-metrics/customer-aliases) for further
      information about how these

      aliases work in Orb.


      In addition to having an identifier in your system, a customer may exist
      in a payment provider solution like

      Stripe. Use the `payment_provider_id` and the `payment_provider` enum
      field to express this mapping.


      A customer also has a timezone (from the standard [IANA timezone
      database](https://www.iana.org/time-zones)), which

      defaults to your account's timezone. See [Timezone
      localization](/essentials/timezones) for

      information on what this timezone parameter influences within Orb.
  - name: Dimensional Price Group
  - name: Event
    description: >-
      The [Event](/core-concepts#event) resource represents a usage event that
      has been created for a

      customer. Events are the core of Orb's usage-based billing model, and are
      used to calculate the usage charges for

      a given billing period.
  - name: Invoice
    description: >-
      An [`Invoice`](/core-concepts#invoice) is a fundamental billing entity,
      representing the request for payment for

      a single subscription. This includes a set of line items, which correspond
      to prices in the subscription's plan and

      can represent fixed recurring fees or usage-based fees. They are generated
      at the end of a billing period, or as

      the result of an action, such as a cancellation.
  - name: Item
    description: >-
      The Item resource represents a sellable product or good. Items are
      associated with all line items, billable metrics,

      and prices and are used for defining external sync behavior for invoices
      and tax calculation purposes.
  - name: License
  - name: LicenseType
    description: >-
      The LicenseType resource represents a type of license that can be assigned
      to users.

      License types are used during billing by grouping metrics on the
      configured grouping key.
  - name: Metric
    description: >-
      The Metric resource represents a calculation of a quantity based on
      events.

      Metrics are defined by the query that transforms raw usage events into
      meaningful values for your customers.
  - name: Plan
    description: >-
      The [Plan](/core-concepts#plan-and-price) resource represents a plan that
      can be subscribed to by a

      customer. Plans define the billing behavior of the subscription. You can
      see more about how to configure prices

      in the [Price resource](/reference/price).
  - name: Price
    description: >-
      The Price resource represents a price that can be billed on a
      subscription, resulting in a charge on an invoice in

      the form of an invoice line item. Prices take a quantity and determine an
      amount to bill.


      Orb supports a few different pricing models out of the box. Each of these
      models is serialized differently in a

      given Price object. The model_type field determines the key for the
      configuration object that is present.


      For more on the types of prices, see [the core concepts
      documentation](/core-concepts#plan-and-price)
  - name: Price interval
    description: >-
      The Price Interval resource represents a period of time for which a price
      will bill on a subscription. A

      subscription’s price intervals define its billing behavior.
  - name: Subscription
    description: >-
      A [subscription](/core-concepts#subscription) represents the purchase of a
      plan by a customer.


      By default, subscriptions begin on the day that they're created and renew
      automatically for each billing cycle at

      the cadence that's configured in the plan definition.


      Subscriptions also default to **beginning of month alignment**, which
      means the first invoice issued for the

      subscription will have pro-rated charges between the `start_date` and the
      first of the following month. Subsequent

      billing periods will always start and end on a month boundary (e.g.
      subsequent month starts for monthly billing).


      Depending on the plan configuration, any _flat_ recurring fees will be
      billed either at the beginning (in-advance)

      or end (in-arrears) of each billing cycle. Plans default to **in-advance
      billing**. Usage-based fees are billed in

      arrears as usage is accumulated. In the normal course of events, you can
      expect an invoice to contain usage-based

      charges for the previous period, and a recurring fee for the following
      period.
  - name: Subscription Change
paths:
  /invoices/{invoice_id}/issue:
    post:
      tags:
        - Invoice
      summary: Issue invoice
      description: >-
        This endpoint allows an eligible invoice to be issued manually. This is
        only possible with invoices where status is `draft`,

        `will_auto_issue` is false, and an `eligible_to_issue_at` is a time in
        the past. Issuing an invoice could possibly trigger

        side effects, some of which could be customer-visible (e.g. sending
        emails, auto-collecting payment,

        syncing the invoice to external providers, etc).
      operationId: issue-invoice
      parameters:
        - required: true
          style: simple
          schema:
            type: string
          name: invoice_id
          in: path
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IssueInvoiceRequestParams'
        required: false
      responses:
        '200':
          description: OK
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Invoice'
        '400':
          description: Bad Request
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/400Error'
        '401':
          description: Unauthorized
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/401Error'
        '404':
          description: Not Found
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/404Error'
        '409':
          description: Conflict
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/409Error'
        '413':
          description: Content Too Large
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/413Error'
        '429':
          description: Too Many Requests
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/429Error'
        '500':
          description: Internal Server Error
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/500Error'
components:
  schemas:
    IssueInvoiceRequestParams:
      properties:
        synchronous:
          type: boolean
          title: Synchronous
          description: >-
            If true, the invoice will be issued synchronously. If false, the
            invoice will be issued asynchronously. The synchronous option is
            only available for invoices that have no usage fees. If the invoice
            is configured to sync to an external provider, a successful response
            from this endpoint guarantees the invoice is present in the
            provider.
          default: false
          examples:
            - true
            - false
      additionalProperties: false
      type: object
      title: IssueInvoiceRequestParams
    Invoice:
      properties:
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        voided_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Voided At
          description: >-
            If the invoice has a status of `void`, this gives a timestamp when
            the invoice was voided.
        paid_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Paid At
          description: >-
            If the invoice has a status of `paid`, this gives a timestamp when
            the invoice was paid.
        issued_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Issued At
          description: >-
            If the invoice has been issued, this will be the time it
            transitioned to `issued` (even if it is now in a different state.)
        scheduled_issue_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Scheduled Issue At
          description: >-
            If the invoice is in draft, this timestamp will reflect when the
            invoice is scheduled to be issued.
        auto_collection:
          $ref: '#/components/schemas/AutoCollection'
        issue_failed_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Issue Failed At
          description: >-
            If the invoice failed to issue, this will be the last time it failed
            to issue (even if it is now in a different state.)
        sync_failed_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Sync Failed At
          description: >-
            If the invoice failed to sync, this will be the last time an
            external invoicing provider sync was attempted. This field will
            always be `null` for invoices using Orb Invoicing.
        payment_failed_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Payment Failed At
          description: >-
            If payment was attempted on this invoice but failed, this will be
            the time of the most recent attempt.
        payment_started_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Payment Started At
          description: >-
            If payment was attempted on this invoice, this will be the start
            time of the most recent attempt. This field is especially useful for
            delayed-notification payment mechanisms (like bank transfers), where
            payment can take 3 days or more.
        amount_due:
          type: string
          title: Amount Due
          description: >-
            This is the final amount required to be charged to the customer and
            reflects the application of the customer balance to the `total` of
            the invoice.
          examples:
            - '8.00'
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The creation time of the resource in Orb.
          examples:
            - '2022-05-01T07:01:31+00:00'
        currency:
          type: string
          title: Currency
          description: An ISO 4217 currency string or `credits`
          examples:
            - USD
        customer:
          $ref: '#/components/schemas/CustomerMinified'
        due_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Due Date
          description: >-
            When the invoice payment is due. The due date is null if the invoice
            is not yet finalized.
          examples:
            - '2022-05-30T07:00:00+00:00'
        id:
          type: string
          title: Id
        invoice_pdf:
          oneOf:
            - type: string
            - type: 'null'
          title: Invoice Pdf
          description: The link to download the PDF representation of the `Invoice`.
          examples:
            - >-
              https://assets.withorb.com/invoice/rUHdhmg45vY45DX/qEAeuYePaphGMdFb
        invoice_number:
          type: string
          title: Invoice Number
          description: >-
            Automatically generated invoice number to help track and reconcile
            invoices. Invoice numbers have a prefix such as `RFOBWG`. These can
            be sequential per account or customer.
          examples:
            - JYEFHK-00001
        subscription:
          oneOf:
            - $ref: '#/components/schemas/SubscriptionMinified'
            - type: 'null'
        total:
          type: string
          title: Total
          description: The total after any minimums and discounts have been applied.
          examples:
            - '8.00'
        customer_balance_transactions:
          items:
            $ref: '#/components/schemas/CustomerBalanceTransaction'
          type: array
          title: Customer Balance Transactions
        status:
          type: string
          enum:
            - issued
            - paid
            - synced
            - void
            - draft
          title: Status
        invoice_source:
          type: string
          enum:
            - subscription
            - partial
            - one_off
          title: Invoice Source
        shipping_address:
          oneOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
        billing_address:
          oneOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
        hosted_invoice_url:
          oneOf:
            - type: string
            - type: 'null'
          title: Hosted Invoice Url
          description: >-
            A URL for the customer-facing invoice portal. This URL expires 60
            days after the link is generated, or 30 days after the invoice's due
            date — whichever is later.
        will_auto_issue:
          type: boolean
          title: Will Auto Issue
          description: >-
            This is true if the invoice will be automatically issued in the
            future, and false otherwise.
        eligible_to_issue_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Eligible To Issue At
          description: >-
            If the invoice has a status of `draft`, this will be the time that
            the invoice will be eligible to be issued, otherwise it will be
            `null`. If `auto-issue` is true, the invoice will automatically
            begin issuing at this time.
        customer_tax_id:
          oneOf:
            - $ref: '#/components/schemas/CustomerTaxId'
            - type: 'null'
        memo:
          oneOf:
            - type: string
            - type: 'null'
          title: Memo
          description: >-
            Free-form text which is available on the invoice PDF and the Orb
            invoice portal.
        credit_notes:
          items:
            $ref: '#/components/schemas/CreditNoteSummary'
          type: array
          title: Credit Notes
          description: A list of credit notes associated with the invoice
        payment_attempts:
          items:
            $ref: '#/components/schemas/PaymentAttempt'
          type: array
          title: Payment Attempts
          description: A list of payment attempts associated with the invoice
        discount:
          oneOf:
            - $ref: '#/components/schemas/DEPRECATED_InvoiceLevelDiscount'
            - type: 'null'
          description: >-
            This field is deprecated in favor of `discounts`. If a `discounts`
            list is provided, the first discount in the list will be returned.
            If the list is empty, `None` will be returned.
          deprecated: true
        discounts:
          items:
            $ref: '#/components/schemas/InvoiceLevelDiscount'
          type: array
          title: Discounts
        minimum:
          oneOf:
            - $ref: '#/components/schemas/Minimum'
            - type: 'null'
        minimum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Minimum Amount
        maximum:
          oneOf:
            - $ref: '#/components/schemas/Maximum'
            - type: 'null'
        maximum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Maximum Amount
        line_items:
          items:
            $ref: '#/components/schemas/InvoiceLineItem'
          type: array
          title: Line Items
          description: The breakdown of prices in this invoice.
        subtotal:
          type: string
          title: Subtotal
          description: The total before any discounts and minimums are applied.
          examples:
            - '8.00'
        invoice_date:
          type: string
          format: date-time
          title: Invoice Date
          description: The scheduled date of the invoice
          examples:
            - '2022-05-01T07:00:00+00:00'
      type: object
      required:
        - metadata
        - voided_at
        - paid_at
        - issued_at
        - scheduled_issue_at
        - auto_collection
        - issue_failed_at
        - sync_failed_at
        - payment_failed_at
        - payment_started_at
        - amount_due
        - created_at
        - currency
        - customer
        - due_date
        - id
        - invoice_pdf
        - invoice_number
        - subscription
        - total
        - customer_balance_transactions
        - status
        - invoice_source
        - shipping_address
        - billing_address
        - hosted_invoice_url
        - will_auto_issue
        - eligible_to_issue_at
        - customer_tax_id
        - memo
        - credit_notes
        - payment_attempts
        - discount
        - discounts
        - minimum
        - minimum_amount
        - maximum
        - maximum_amount
        - line_items
        - subtotal
        - invoice_date
      title: Invoice
      description: >-
        An [`Invoice`](/core-concepts#invoice) is a fundamental billing entity,
        representing the request for payment for

        a single subscription. This includes a set of line items, which
        correspond to prices in the subscription's plan and

        can represent fixed recurring fees or usage-based fees. They are
        generated at the end of a billing period, or as

        the result of an action, such as a cancellation.
    400Error:
      oneOf:
        - $ref: '#/components/schemas/ConstraintViolationError'
        - $ref: '#/components/schemas/DuplicateResourceCreationError'
        - $ref: '#/components/schemas/RequestValidationError'
    401Error:
      $ref: '#/components/schemas/AuthorizationError'
      title: 401Error
    404Error:
      oneOf:
        - $ref: '#/components/schemas/FeatureNotAvailableError'
        - $ref: '#/components/schemas/ResourceNotFoundError'
        - $ref: '#/components/schemas/URLNotFound'
    409Error:
      $ref: '#/components/schemas/IdempotencyRequestMismatch'
      title: 409Error
    413Error:
      oneOf:
        - $ref: '#/components/schemas/RequestTooLargeError'
        - $ref: '#/components/schemas/ResourceTooLargeError'
        - $ref: '#/components/schemas/TooManyResultsError'
    429Error:
      $ref: '#/components/schemas/TooManyRequests'
      title: 429Error
    500Error:
      $ref: '#/components/schemas/ServerError'
      title: 500Error
    AutoCollection:
      properties:
        next_attempt_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Next Attempt At
          description: >-
            If the invoice is scheduled for auto-collection, this field will
            reflect when the next attempt will occur. If dunning has been
            exhausted, or auto-collection is not enabled for this invoice, this
            field will be `null`.
        previously_attempted_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Previously Attempted At
          description: >-
            If Orb has ever attempted payment auto-collection for this invoice,
            this field will reflect when that attempt occurred. In conjunction
            with `next_attempt_at`, this can be used to tell whether the invoice
            is currently in dunning (that is, `previously_attempted_at` is
            non-null, and `next_attempt_time` is non-null), or if dunning has
            been exhausted (`previously_attempted_at` is non-null, but
            `next_attempt_time` is null).
        enabled:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Enabled
          description: True only if auto-collection is enabled for this invoice.
        num_attempts:
          oneOf:
            - type: integer
            - type: 'null'
          title: Num Attempts
          description: Number of auto-collection payment attempts.
      type: object
      required:
        - next_attempt_at
        - previously_attempted_at
        - enabled
        - num_attempts
      title: AutoCollection
    CustomerMinified:
      properties:
        id:
          type: string
          title: Id
        external_customer_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Customer Id
      type: object
      required:
        - id
        - external_customer_id
      title: CustomerMinified
    SubscriptionMinified:
      properties:
        id:
          type: string
          title: Id
          examples:
            - VDGsT23osdLb84KD
      type: object
      required:
        - id
      title: SubscriptionMinified
    CustomerBalanceTransaction:
      properties:
        id:
          type: string
          title: Id
          description: A unique id for this transaction.
          examples:
            - cgZa3SXcsPTVyC4Y
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The creation time of this transaction.
          examples:
            - '2022-05-01T07:01:31+00:00'
        starting_balance:
          type: string
          title: Starting Balance
          description: >-
            The original value of the customer's balance prior to the
            transaction, in the customer's currency.
          examples:
            - '33.00'
        ending_balance:
          type: string
          title: Ending Balance
          description: >-
            The new value of the customer's balance prior to the transaction, in
            the customer's currency.
          examples:
            - '22.00'
        amount:
          type: string
          title: Amount
          description: The value of the amount changed in the transaction.
          examples:
            - '11.00'
        action:
          type: string
          enum:
            - applied_to_invoice
            - manual_adjustment
            - prorated_refund
            - revert_prorated_refund
            - return_from_voiding
            - credit_note_applied
            - credit_note_voided
            - overpayment_refund
            - external_payment
            - small_invoice_carryover
          title: Action
        description:
          oneOf:
            - type: string
            - type: 'null'
          title: Description
          description: >-
            An optional description provided for manual customer balance
            adjustments.
          examples:
            - An optional description
        invoice:
          oneOf:
            - $ref: '#/components/schemas/InvoiceTiny'
            - type: 'null'
        type:
          type: string
          enum:
            - increment
            - decrement
          title: Type
        credit_note:
          oneOf:
            - $ref: '#/components/schemas/CreditNoteTiny'
            - type: 'null'
      type: object
      required:
        - id
        - created_at
        - starting_balance
        - ending_balance
        - amount
        - action
        - description
        - invoice
        - type
        - credit_note
      title: CustomerBalanceTransaction
    Address:
      properties:
        line1:
          oneOf:
            - type: string
            - type: 'null'
          title: Line1
        line2:
          oneOf:
            - type: string
            - type: 'null'
          title: Line2
        city:
          oneOf:
            - type: string
            - type: 'null'
          title: City
        state:
          oneOf:
            - type: string
            - type: 'null'
          title: State
        postal_code:
          oneOf:
            - type: string
            - type: 'null'
          title: Postal Code
        country:
          oneOf:
            - type: string
            - type: 'null'
          title: Country
      type: object
      required:
        - line1
        - line2
        - city
        - state
        - postal_code
        - country
      title: Address
    CustomerTaxId:
      properties:
        country:
          type: string
          enum:
            - AD
            - AE
            - AL
            - AM
            - AO
            - AR
            - AT
            - AU
            - AW
            - AZ
            - BA
            - BB
            - BD
            - BE
            - BF
            - BG
            - BH
            - BJ
            - BO
            - BR
            - BS
            - BY
            - CA
            - CD
            - CH
            - CL
            - CM
            - CN
            - CO
            - CR
            - CV
            - CY
            - CZ
            - DE
            - DK
            - DO
            - EC
            - EE
            - EG
            - ES
            - ET
            - EU
            - FI
            - FO
            - FR
            - GB
            - GE
            - GI
            - GN
            - GR
            - HK
            - HR
            - HU
            - ID
            - IE
            - IL
            - IN
            - IS
            - IT
            - JP
            - KE
            - KG
            - KH
            - KR
            - KZ
            - LA
            - LI
            - LK
            - LT
            - LU
            - LV
            - MA
            - MD
            - ME
            - MK
            - MR
            - MT
            - MX
            - MY
            - NG
            - NL
            - 'NO'
            - NP
            - NZ
            - OM
            - PE
            - PH
            - PL
            - PT
            - PY
            - RO
            - RS
            - RU
            - SA
            - SE
            - SG
            - SI
            - SK
            - SN
            - SR
            - SV
            - TH
            - TJ
            - TR
            - TW
            - TZ
            - UA
            - UG
            - US
            - UY
            - UZ
            - VE
            - VN
            - ZA
            - ZM
            - ZW
          title: Country
        type:
          type: string
          enum:
            - ad_nrt
            - ae_trn
            - al_tin
            - am_tin
            - ao_tin
            - ar_cuit
            - eu_vat
            - au_abn
            - au_arn
            - aw_tin
            - az_tin
            - ba_tin
            - bb_tin
            - bd_bin
            - bf_ifu
            - bg_uic
            - bh_vat
            - bj_ifu
            - bo_tin
            - br_cnpj
            - br_cpf
            - bs_tin
            - by_tin
            - ca_bn
            - ca_gst_hst
            - ca_pst_bc
            - ca_pst_mb
            - ca_pst_sk
            - ca_qst
            - cd_nif
            - ch_uid
            - ch_vat
            - cl_tin
            - cm_niu
            - cn_tin
            - co_nit
            - cr_tin
            - cv_nif
            - de_stn
            - do_rcn
            - ec_ruc
            - eg_tin
            - es_cif
            - et_tin
            - eu_oss_vat
            - fo_vat
            - gb_vat
            - ge_vat
            - gi_tin
            - gn_nif
            - hk_br
            - hr_oib
            - hu_tin
            - id_npwp
            - il_vat
            - in_gst
            - is_vat
            - it_cf
            - jp_cn
            - jp_rn
            - jp_trn
            - ke_pin
            - kg_tin
            - kh_tin
            - kr_brn
            - kz_bin
            - la_tin
            - li_uid
            - li_vat
            - lk_vat
            - ma_vat
            - md_vat
            - me_pib
            - mk_vat
            - mr_nif
            - mx_rfc
            - my_frp
            - my_itn
            - my_sst
            - ng_tin
            - no_vat
            - no_voec
            - np_pan
            - nz_gst
            - om_vat
            - pe_ruc
            - ph_tin
            - pl_nip
            - py_ruc
            - ro_tin
            - rs_pib
            - ru_inn
            - ru_kpp
            - sa_vat
            - sg_gst
            - sg_uen
            - si_tin
            - sn_ninea
            - sr_fin
            - sv_nit
            - th_vat
            - tj_tin
            - tr_tin
            - tw_vat
            - tz_vat
            - ua_vat
            - ug_tin
            - us_ein
            - uy_ruc
            - uz_tin
            - uz_vat
            - ve_rif
            - vn_tin
            - za_vat
            - zm_tin
            - zw_tin
          title: Type
        value:
          type: string
          title: Value
      type: object
      required:
        - country
        - type
        - value
      title: CustomerTaxId
      description: >-
        Tax IDs are commonly required to be displayed on customer invoices,
        which are added to the headers of invoices.



        ### Supported Tax ID Countries and Types



        | Country | Type | Description |

        |---------|------|-------------|

        | Albania | `al_tin` | Albania Tax Identification Number |

        | Andorra | `ad_nrt` | Andorran NRT Number |

        | Angola | `ao_tin` | Angola Tax Identification Number |

        | Argentina | `ar_cuit` | Argentinian Tax ID Number |

        | Armenia | `am_tin` | Armenia Tax Identification Number |

        | Aruba | `aw_tin` | Aruba Tax Identification Number |

        | Australia | `au_abn` | Australian Business Number (AU ABN) |

        | Australia | `au_arn` | Australian Taxation Office Reference Number |

        | Austria | `eu_vat` | European VAT Number |

        | Azerbaijan | `az_tin` | Azerbaijan Tax Identification Number |

        | Bahamas | `bs_tin` | Bahamas Tax Identification Number |

        | Bahrain | `bh_vat` | Bahraini VAT Number |

        | Bangladesh | `bd_bin` | Bangladesh Business Identification Number |

        | Barbados | `bb_tin` | Barbados Tax Identification Number |

        | Belarus | `by_tin` | Belarus TIN Number |

        | Belgium | `eu_vat` | European VAT Number |

        | Benin | `bj_ifu` | Benin Tax Identification Number (Identifiant Fiscal
        Unique) |

        | Bolivia | `bo_tin` | Bolivian Tax ID |

        | Bosnia and Herzegovina | `ba_tin` | Bosnia and Herzegovina Tax
        Identification Number |

        | Brazil | `br_cnpj` | Brazilian CNPJ Number |

        | Brazil | `br_cpf` | Brazilian CPF Number |

        | Bulgaria | `bg_uic` | Bulgaria Unified Identification Code |

        | Bulgaria | `eu_vat` | European VAT Number |

        | Burkina Faso | `bf_ifu` | Burkina Faso Tax Identification Number
        (Numéro d'Identifiant Fiscal Unique) |

        | Cambodia | `kh_tin` | Cambodia Tax Identification Number |

        | Cameroon | `cm_niu` | Cameroon Tax Identification Number (Numéro
        d'Identifiant fiscal Unique) |

        | Canada | `ca_bn` | Canadian BN |

        | Canada | `ca_gst_hst` | Canadian GST/HST Number |

        | Canada | `ca_pst_bc` | Canadian PST Number (British Columbia) |

        | Canada | `ca_pst_mb` | Canadian PST Number (Manitoba) |

        | Canada | `ca_pst_sk` | Canadian PST Number (Saskatchewan) |

        | Canada | `ca_qst` | Canadian QST Number (Québec) |

        | Cape Verde | `cv_nif` | Cape Verde Tax Identification Number (Número
        de Identificação Fiscal) |

        | Chile | `cl_tin` | Chilean TIN |

        | China | `cn_tin` | Chinese Tax ID |

        | Colombia | `co_nit` | Colombian NIT Number |

        | Congo-Kinshasa | `cd_nif` | Congo (DR) Tax Identification Number
        (Número de Identificação Fiscal) |

        | Costa Rica | `cr_tin` | Costa Rican Tax ID |

        | Croatia | `eu_vat` | European VAT Number |

        | Croatia | `hr_oib` | Croatian Personal Identification Number (OIB) |

        | Cyprus | `eu_vat` | European VAT Number |

        | Czech Republic | `eu_vat` | European VAT Number |

        | Denmark | `eu_vat` | European VAT Number |

        | Dominican Republic | `do_rcn` | Dominican RCN Number |

        | Ecuador | `ec_ruc` | Ecuadorian RUC Number |

        | Egypt | `eg_tin` | Egyptian Tax Identification Number |

        | El Salvador | `sv_nit` | El Salvadorian NIT Number |

        | Estonia | `eu_vat` | European VAT Number |

        | Ethiopia | `et_tin` | Ethiopia Tax Identification Number |

        | European Union | `eu_oss_vat` | European One Stop Shop VAT Number for
        non-Union scheme |

        | Faroe Islands | `fo_vat` | Faroe Islands VAT Number |

        | Finland | `eu_vat` | European VAT Number |

        | France | `eu_vat` | European VAT Number |

        | Georgia | `ge_vat` | Georgian VAT |

        | Germany | `de_stn` | German Tax Number (Steuernummer) |

        | Germany | `eu_vat` | European VAT Number |

        | Gibraltar | `gi_tin` | Gibraltar Tax Identification Number |

        | Greece | `eu_vat` | European VAT Number |

        | Guinea | `gn_nif` | Guinea Tax Identification Number (Número de
        Identificação Fiscal) |

        | Hong Kong | `hk_br` | Hong Kong BR Number |

        | Hungary | `eu_vat` | European VAT Number |

        | Hungary | `hu_tin` | Hungary Tax Number (adószám) |

        | Iceland | `is_vat` | Icelandic VAT |

        | India | `in_gst` | Indian GST Number |

        | Indonesia | `id_npwp` | Indonesian NPWP Number |

        | Ireland | `eu_vat` | European VAT Number |

        | Israel | `il_vat` | Israel VAT |

        | Italy | `eu_vat` | European VAT Number |

        | Italy | `it_cf` | Italian Codice Fiscale Number |

        | Japan | `jp_cn` | Japanese Corporate Number (*Hōjin Bangō*) |

        | Japan | `jp_rn` | Japanese Registered Foreign Businesses' Registration
        Number (*Tōroku Kokugai Jigyōsha no Tōroku Bangō*) |

        | Japan | `jp_trn` | Japanese Tax Registration Number (*Tōroku Bangō*) |

        | Kazakhstan | `kz_bin` | Kazakhstani Business Identification Number |

        | Kenya | `ke_pin` | Kenya Revenue Authority Personal Identification
        Number |

        | Kyrgyzstan | `kg_tin` | Kyrgyzstan Tax Identification Number |

        | Laos | `la_tin` | Laos Tax Identification Number |

        | Latvia | `eu_vat` | European VAT Number |

        | Liechtenstein | `li_uid` | Liechtensteinian UID Number |

        | Liechtenstein | `li_vat` | Liechtenstein VAT Number |

        | Lithuania | `eu_vat` | European VAT Number |

        | Luxembourg | `eu_vat` | European VAT Number |

        | Malaysia | `my_frp` | Malaysian FRP Number |

        | Malaysia | `my_itn` | Malaysian ITN |

        | Malaysia | `my_sst` | Malaysian SST Number |

        | Malta | `eu_vat` | European VAT Number |

        | Mauritania | `mr_nif` | Mauritania Tax Identification Number (Número
        de Identificação Fiscal) |

        | Mexico | `mx_rfc` | Mexican RFC Number |

        | Moldova | `md_vat` | Moldova VAT Number |

        | Montenegro | `me_pib` | Montenegro PIB Number |

        | Morocco | `ma_vat` | Morocco VAT Number |

        | Nepal | `np_pan` | Nepal PAN Number |

        | Netherlands | `eu_vat` | European VAT Number |

        | New Zealand | `nz_gst` | New Zealand GST Number |

        | Nigeria | `ng_tin` | Nigerian Tax Identification Number |

        | North Macedonia | `mk_vat` | North Macedonia VAT Number |

        | Northern Ireland | `eu_vat` | Northern Ireland VAT Number |

        | Norway | `no_vat` | Norwegian VAT Number |

        | Norway | `no_voec` | Norwegian VAT on e-commerce Number |

        | Oman | `om_vat` | Omani VAT Number |

        | Paraguay | `py_ruc` | Paraguayan RUC Number |

        | Peru | `pe_ruc` | Peruvian RUC Number |

        | Philippines | `ph_tin` | Philippines Tax Identification Number |

        | Poland | `eu_vat` | European VAT Number |

        | Poland | `pl_nip` | Polish Tax ID Number |

        | Portugal | `eu_vat` | European VAT Number |

        | Romania | `eu_vat` | European VAT Number |

        | Romania | `ro_tin` | Romanian Tax ID Number |

        | Russia | `ru_inn` | Russian INN |

        | Russia | `ru_kpp` | Russian KPP |

        | Saudi Arabia | `sa_vat` | Saudi Arabia VAT |

        | Senegal | `sn_ninea` | Senegal NINEA Number |

        | Serbia | `rs_pib` | Serbian PIB Number |

        | Singapore | `sg_gst` | Singaporean GST |

        | Singapore | `sg_uen` | Singaporean UEN |

        | Slovakia | `eu_vat` | European VAT Number |

        | Slovenia | `eu_vat` | European VAT Number |

        | Slovenia | `si_tin` | Slovenia Tax Number (davčna številka) |

        | South Africa | `za_vat` | South African VAT Number |

        | South Korea | `kr_brn` | Korean BRN |

        | Spain | `es_cif` | Spanish NIF Number (previously Spanish CIF Number)
        |

        | Spain | `eu_vat` | European VAT Number |

        | Sri Lanka | `lk_vat` | Sri Lanka VAT Number |

        | Suriname | `sr_fin` | Suriname FIN Number |

        | Sweden | `eu_vat` | European VAT Number |

        | Switzerland | `ch_uid` | Switzerland UID Number |

        | Switzerland | `ch_vat` | Switzerland VAT Number |

        | Taiwan | `tw_vat` | Taiwanese VAT |

        | Tajikistan | `tj_tin` | Tajikistan Tax Identification Number |

        | Tanzania | `tz_vat` | Tanzania VAT Number |

        | Thailand | `th_vat` | Thai VAT |

        | Turkey | `tr_tin` | Turkish Tax Identification Number |

        | Uganda | `ug_tin` | Uganda Tax Identification Number |

        | Ukraine | `ua_vat` | Ukrainian VAT |

        | United Arab Emirates | `ae_trn` | United Arab Emirates TRN |

        | United Kingdom | `gb_vat` | United Kingdom VAT Number |

        | United States | `us_ein` | United States EIN |

        | Uruguay | `uy_ruc` | Uruguayan RUC Number |

        | Uzbekistan | `uz_tin` | Uzbekistan TIN Number |

        | Uzbekistan | `uz_vat` | Uzbekistan VAT Number |

        | Venezuela | `ve_rif` | Venezuelan RIF Number |

        | Vietnam | `vn_tin` | Vietnamese Tax ID Number |

        | Zambia | `zm_tin` | Zambia Tax Identification Number |

        | Zimbabwe | `zw_tin` | Zimbabwe Tax Identification Number |
    CreditNoteSummary:
      properties:
        id:
          type: string
          title: Id
        credit_note_number:
          type: string
          title: Credit Note Number
        reason:
          type: string
          title: Reason
        total:
          type: string
          title: Total
        voided_at:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Voided At
          description: >-
            If the credit note has a status of `void`, this gives a timestamp
            when the credit note was voided.
          examples:
            - '2022-05-01T07:01:31+00:00'
        type:
          type: string
          title: Type
        memo:
          oneOf:
            - type: string
            - type: 'null'
          title: Memo
          description: An optional memo supplied on the credit note.
      type: object
      required:
        - id
        - credit_note_number
        - reason
        - total
        - voided_at
        - type
        - memo
      title: CreditNoteSummary
    PaymentAttempt:
      properties:
        id:
          type: string
          title: Id
          description: The ID of the payment attempt.
        payment_provider:
          oneOf:
            - type: string
              enum:
                - stripe
                - adyen
            - type: 'null'
          title: Payment Provider
          description: The payment provider that attempted to collect the payment.
        payment_provider_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Payment Provider Id
          description: The ID of the payment attempt in the payment provider.
        amount:
          type: string
          title: Amount
          description: The amount of the payment attempt.
        succeeded:
          type: boolean
          title: Succeeded
          description: Whether the payment attempt succeeded.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The time at which the payment attempt was created.
        receipt_pdf:
          oneOf:
            - type: string
            - type: 'null'
          title: Receipt Pdf
          description: >-
            URL to the downloadable PDF version of the receipt. This field will
            be `null` for payment attempts that did not succeed.
          examples:
            - >-
              https://assets.withorb.com/receipt/rUHdhmg45vY45DX/qEAeuYePaphGMdFb
      type: object
      required:
        - id
        - payment_provider
        - payment_provider_id
        - amount
        - succeeded
        - created_at
        - receipt_pdf
      title: PaymentAttempt
    DEPRECATED_InvoiceLevelDiscount:
      title: DEPRECATED_InvoiceLevelDiscount
      deprecated: true
    InvoiceLevelDiscount:
      oneOf:
        - $ref: '#/components/schemas/PercentageDiscount'
        - $ref: '#/components/schemas/AmountDiscount'
        - $ref: '#/components/schemas/TrialDiscount'
      discriminator:
        propertyName: discount_type
        mapping:
          amount:
            $ref: '#/components/schemas/AmountDiscount'
          percentage:
            $ref: '#/components/schemas/PercentageDiscount'
          trial:
            $ref: '#/components/schemas/TrialDiscount'
    Minimum:
      properties:
        minimum_amount:
          type: string
          title: Minimum Amount
          description: Minimum amount applied
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this minimum to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: >-
            List of price_ids that this minimum amount applies to. For plan/plan
            phase minimums, this can be a subset of prices.
          deprecated: true
      type: object
      required:
        - minimum_amount
        - filters
        - applies_to_price_ids
      title: Minimum
    Maximum:
      properties:
        maximum_amount:
          type: string
          title: Maximum Amount
          description: Maximum amount applied
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this maximum to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: >-
            List of price_ids that this maximum amount applies to. For plan/plan
            phase maximums, this can be a subset of prices.
          deprecated: true
      type: object
      required:
        - maximum_amount
        - filters
        - applies_to_price_ids
      title: Maximum
    InvoiceLineItem:
      properties:
        amount:
          type: string
          title: Amount
          description: >-
            The final amount for a line item after all adjustments and pre paid
            credits have been applied.
          examples:
            - '7.00'
        end_date:
          type: string
          format: date-time
          title: End Date
          description: >-
            The end date of the range of time applied for this line item's
            price.
          examples:
            - '2022-02-01T08:00:00+00:00'
        grouping:
          oneOf:
            - type: string
            - type: 'null'
          title: Grouping
          description: >-
            [DEPRECATED] For configured prices that are split by a grouping key,
            this will be populated with the key and a value. The `amount` and
            `subtotal` will be the values for this particular grouping.
        adjustments:
          items:
            $ref: '#/components/schemas/MonetaryAdjustment'
          type: array
          title: Adjustments
          description: >-
            All adjustments applied to the line item in the order they were
            applied based on invoice calculations (ie. usage discounts -> amount
            discounts -> percentage discounts -> minimums -> maximums).
        name:
          type: string
          title: Name
          description: The name of the price associated with this line item.
          examples:
            - Fixed Fee
        quantity:
          type: number
          title: Quantity
          description: >-
            Either the fixed fee quantity or the usage during the service
            period.
          examples:
            - 1
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: >-
            The start date of the range of time applied for this line item's
            price.
          examples:
            - '2022-02-01T08:00:00+00:00'
        subtotal:
          type: string
          title: Subtotal
          description: The line amount before any adjustments.
          examples:
            - '9.00'
        adjusted_subtotal:
          type: string
          title: Adjusted Subtotal
          description: >-
            The line amount after any adjustments and before overage conversion,
            credits and partial invoicing.
          examples:
            - '5.00'
        credits_applied:
          type: string
          title: Credits Applied
          description: The number of prepaid credits applied.
          examples:
            - '6.00'
        partially_invoiced_amount:
          type: string
          title: Partially Invoiced Amount
          description: Any amount applied from a partial invoice
          examples:
            - '4.00'
        sub_line_items:
          items:
            $ref: '#/components/schemas/InvoiceSubLineItem'
          type: array
          title: Sub Line Items
          description: >-
            For complex pricing structures, the line item can be broken down
            further in `sub_line_items`.
        tax_amounts:
          items:
            $ref: '#/components/schemas/TaxAmount'
          type: array
          title: Tax Amounts
          description: >-
            An array of tax rates and their incurred tax amounts. Empty if no
            tax integration is configured.
        id:
          type: string
          title: Id
          description: A unique ID for this line item.
        price:
          $ref: '#/components/schemas/Price'
        usage_customer_ids:
          oneOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Usage Customer Ids
          description: >-
            A list of customer ids that were used to calculate the usage for
            this line item.
        filter:
          oneOf:
            - type: string
            - type: 'null'
          title: Filter
          description: >-
            An additional filter that was used to calculate the usage for this
            line item.
      type: object
      required:
        - amount
        - end_date
        - grouping
        - adjustments
        - name
        - quantity
        - start_date
        - subtotal
        - adjusted_subtotal
        - credits_applied
        - partially_invoiced_amount
        - sub_line_items
        - tax_amounts
        - id
        - price
        - usage_customer_ids
        - filter
      title: InvoiceLineItem
    ConstraintViolationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-constraint-violation
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ConstraintViolationError
    DuplicateResourceCreationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-duplicate-resource-creation
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: DuplicateResourceCreationError
    RequestValidationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-request-validation-errors
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
        validation_errors:
          items: {}
          type: array
          title: Validation Errors
      type: object
      required:
        - type
        - status
        - validation_errors
      title: RequestValidationError
    AuthorizationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#401-authentication-error
          title: Type
        status:
          type: integer
          enum:
            - 401
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: AuthorizationError
    FeatureNotAvailableError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-feature-not-available
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: FeatureNotAvailableError
    ResourceNotFoundError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-resource-not-found
          title: Type
        status:
          type: integer
          enum:
            - 404
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          type: string
          title: Title
      type: object
      required:
        - type
        - status
        - title
      title: ResourceNotFoundError
    URLNotFound:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-url-not-found
          title: Type
        status:
          type: integer
          enum:
            - 404
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: URLNotFound
    IdempotencyRequestMismatch:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#409-resource-conflict
          title: Type
        status:
          type: integer
          enum:
            - 409
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: IdempotencyRequestMismatch
    RequestTooLargeError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-request-too-large
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: RequestTooLargeError
    ResourceTooLargeError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-resource-too-large
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ResourceTooLargeError
    TooManyResultsError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-too-many-results
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: TooManyResultsError
    TooManyRequests:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#429-too-many-requests
          title: Type
        status:
          type: integer
          enum:
            - 429
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: TooManyRequests
    ServerError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#500-internal-server-error
          title: Type
        status:
          type: integer
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ServerError
    InvoiceTiny:
      properties:
        id:
          type: string
          title: Id
          description: The Invoice id
          examples:
            - gXcsPTVyC4YZa3Sc
      type: object
      required:
        - id
      title: InvoiceTiny
    CreditNoteTiny:
      properties:
        id:
          type: string
          title: Id
          description: The id of the Credit note
      type: object
      required:
        - id
      title: CreditNoteTiny
    PercentageDiscount:
      properties:
        discount_type:
          type: string
          enum:
            - percentage
          title: Discount Type
        applies_to_price_ids:
          oneOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Applies To Price Ids
          description: >-
            List of price_ids that this discount applies to. For plan/plan phase
            discounts, this can be a subset of prices.
          examples:
            - - h74gfhdjvn7ujokd
              - 7hfgtgjnbvc3ujkl
        filters:
          oneOf:
            - items:
                $ref: '#/components/schemas/PriceFilter'
              type: array
            - type: 'null'
          title: Filters
          description: The filters that determine which prices to apply this discount to.
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
        percentage_discount:
          type: number
          maximum: 1
          minimum: 0
          title: Percentage Discount
          description: >-
            Only available if discount_type is `percentage`. This is a number
            between 0 and 1.
          examples:
            - 0.15
      type: object
      required:
        - discount_type
        - percentage_discount
      title: PercentageDiscount
    AmountDiscount:
      properties:
        discount_type:
          type: string
          enum:
            - amount
          title: Discount Type
        applies_to_price_ids:
          oneOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Applies To Price Ids
          description: >-
            List of price_ids that this discount applies to. For plan/plan phase
            discounts, this can be a subset of prices.
          examples:
            - - h74gfhdjvn7ujokd
              - 7hfgtgjnbvc3ujkl
        filters:
          oneOf:
            - items:
                $ref: '#/components/schemas/PriceFilter'
              type: array
            - type: 'null'
          title: Filters
          description: The filters that determine which prices to apply this discount to.
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
        amount_discount:
          type: string
          title: Amount Discount
          description: Only available if discount_type is `amount`.
      type: object
      required:
        - discount_type
        - amount_discount
      title: AmountDiscount
    TrialDiscount:
      properties:
        discount_type:
          type: string
          enum:
            - trial
          title: Discount Type
        applies_to_price_ids:
          oneOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Applies To Price Ids
          description: >-
            List of price_ids that this discount applies to. For plan/plan phase
            discounts, this can be a subset of prices.
          examples:
            - - h74gfhdjvn7ujokd
              - 7hfgtgjnbvc3ujkl
        filters:
          oneOf:
            - items:
                $ref: '#/components/schemas/PriceFilter'
              type: array
            - type: 'null'
          title: Filters
          description: The filters that determine which prices to apply this discount to.
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
        trial_amount_discount:
          oneOf:
            - type: string
            - type: 'null'
          title: Trial Amount Discount
          description: Only available if discount_type is `trial`
        trial_percentage_discount:
          oneOf:
            - type: number
            - type: 'null'
          title: Trial Percentage Discount
          description: Only available if discount_type is `trial`
      type: object
      required:
        - discount_type
      title: TrialDiscount
    PriceFilter:
      properties:
        field:
          type: string
          enum:
            - price_id
            - item_id
            - price_type
            - currency
            - pricing_unit_id
          title: Field
          description: The property of the price to filter on.
        operator:
          type: string
          enum:
            - includes
            - excludes
          title: Operator
          description: Should prices that match the filter be included or excluded.
        values:
          items:
            type: string
          type: array
          uniqueItems: true
          title: Values
          description: The IDs or values that match this filter.
      type: object
      required:
        - field
        - operator
        - values
      title: PriceFilter
    MonetaryAdjustment:
      oneOf:
        - $ref: '#/components/schemas/MonetaryUsageDiscountAdjustment'
        - $ref: '#/components/schemas/MonetaryAmountDiscountAdjustment'
        - $ref: '#/components/schemas/MonetaryPercentageDiscountAdjustment'
        - $ref: '#/components/schemas/MonetaryMinimumAdjustment'
        - $ref: '#/components/schemas/MonetaryMaximumAdjustment'
      discriminator:
        propertyName: adjustment_type
        mapping:
          amount_discount:
            $ref: '#/components/schemas/MonetaryAmountDiscountAdjustment'
          maximum:
            $ref: '#/components/schemas/MonetaryMaximumAdjustment'
          minimum:
            $ref: '#/components/schemas/MonetaryMinimumAdjustment'
          percentage_discount:
            $ref: '#/components/schemas/MonetaryPercentageDiscountAdjustment'
          usage_discount:
            $ref: '#/components/schemas/MonetaryUsageDiscountAdjustment'
    InvoiceSubLineItem:
      oneOf:
        - $ref: '#/components/schemas/MatrixSubLineItem'
        - $ref: '#/components/schemas/TierSubLineItem'
        - $ref: '#/components/schemas/OtherSubLineItem'
      discriminator:
        propertyName: type
        mapping:
          '''null''':
            $ref: '#/components/schemas/OtherSubLineItem'
          matrix:
            $ref: '#/components/schemas/MatrixSubLineItem'
          tier:
            $ref: '#/components/schemas/TierSubLineItem'
    TaxAmount:
      properties:
        tax_rate_description:
          type: string
          title: Tax Rate Description
          description: The human-readable description of the applied tax rate.
        tax_rate_percentage:
          oneOf:
            - type: string
            - type: 'null'
          title: Tax Rate Percentage
          description: The tax rate percentage, out of 100.
        amount:
          type: string
          title: Amount
          description: The amount of additional tax incurred by this tax rate.
      type: object
      required:
        - tax_rate_description
        - tax_rate_percentage
        - amount
      title: TaxAmount
    Price:
      oneOf:
        - $ref: '#/components/schemas/UnitPrice'
        - $ref: '#/components/schemas/TieredPrice'
        - $ref: '#/components/schemas/BulkPrice'
        - $ref: '#/components/schemas/BulkWithFiltersPrice'
        - $ref: '#/components/schemas/PackagePrice'
        - $ref: '#/components/schemas/MatrixPrice'
        - $ref: '#/components/schemas/ThresholdTotalAmountPrice'
        - $ref: '#/components/schemas/TieredPackagePrice'
        - $ref: '#/components/schemas/TieredWithMinimumPrice'
        - $ref: '#/components/schemas/GroupedTieredPrice'
        - $ref: '#/components/schemas/TieredPackageWithMinimumPrice'
        - $ref: '#/components/schemas/PackageWithAllocationPrice'
        - $ref: '#/components/schemas/UnitWithPercentPrice'
        - $ref: '#/components/schemas/MatrixWithAllocationPrice'
        - $ref: '#/components/schemas/MatrixWithThresholdDiscountsPrice'
        - $ref: '#/components/schemas/TieredWithProrationPrice'
        - $ref: '#/components/schemas/UnitWithProrationPrice'
        - $ref: '#/components/schemas/GroupedAllocationPrice'
        - $ref: '#/components/schemas/BulkWithProrationPrice'
        - $ref: '#/components/schemas/GroupedWithProratedMinimumPrice'
        - $ref: '#/components/schemas/GroupedWithMeteredMinimumPrice'
        - $ref: '#/components/schemas/GroupedWithMinMaxThresholdsPrice'
        - $ref: '#/components/schemas/MatrixWithDisplayNamePrice'
        - $ref: '#/components/schemas/GroupedTieredPackagePrice'
        - $ref: '#/components/schemas/MaxGroupTieredPackagePrice'
        - $ref: '#/components/schemas/ScalableMatrixWithUnitPricingPrice'
        - $ref: '#/components/schemas/ScalableMatrixWithTieredPricingPrice'
        - $ref: '#/components/schemas/CumulativeGroupedBulkPrice'
        - $ref: '#/components/schemas/CumulativeGroupedAllocationPrice'
        - $ref: '#/components/schemas/DailyCreditAllowancePrice'
        - $ref: '#/components/schemas/MeteredAllowancePrice'
        - $ref: '#/components/schemas/MinimumCompositePrice'
        - $ref: '#/components/schemas/PercentCompositePrice'
        - $ref: '#/components/schemas/EventOutputPrice'
      description: >-
        The Price resource represents a price that can be billed on a
        subscription, resulting in a charge on an invoice in

        the form of an invoice line item. Prices take a quantity and determine
        an amount to bill.


        Orb supports a few different pricing models out of the box. Each of
        these models is serialized differently in a

        given Price object. The model_type field determines the key for the
        configuration object that is present.


        For more on the types of prices, see [the core concepts
        documentation](/core-concepts#plan-and-price)
      discriminator:
        propertyName: model_type
        mapping:
          bulk:
            $ref: '#/components/schemas/BulkPrice'
          bulk_with_filters:
            $ref: '#/components/schemas/BulkWithFiltersPrice'
          bulk_with_proration:
            $ref: '#/components/schemas/BulkWithProrationPrice'
          cumulative_grouped_allocation:
            $ref: '#/components/schemas/CumulativeGroupedAllocationPrice'
          cumulative_grouped_bulk:
            $ref: '#/components/schemas/CumulativeGroupedBulkPrice'
          daily_credit_allowance:
            $ref: '#/components/schemas/DailyCreditAllowancePrice'
          event_output:
            $ref: '#/components/schemas/EventOutputPrice'
          grouped_allocation:
            $ref: '#/components/schemas/GroupedAllocationPrice'
          grouped_tiered:
            $ref: '#/components/schemas/GroupedTieredPrice'
          grouped_tiered_package:
            $ref: '#/components/schemas/GroupedTieredPackagePrice'
          grouped_with_metered_minimum:
            $ref: '#/components/schemas/GroupedWithMeteredMinimumPrice'
          grouped_with_min_max_thresholds:
            $ref: '#/components/schemas/GroupedWithMinMaxThresholdsPrice'
          grouped_with_prorated_minimum:
            $ref: '#/components/schemas/GroupedWithProratedMinimumPrice'
          matrix:
            $ref: '#/components/schemas/MatrixPrice'
          matrix_with_allocation:
            $ref: '#/components/schemas/MatrixWithAllocationPrice'
          matrix_with_display_name:
            $ref: '#/components/schemas/MatrixWithDisplayNamePrice'
          matrix_with_threshold_discounts:
            $ref: '#/components/schemas/MatrixWithThresholdDiscountsPrice'
          max_group_tiered_package:
            $ref: '#/components/schemas/MaxGroupTieredPackagePrice'
          metered_allowance:
            $ref: '#/components/schemas/MeteredAllowancePrice'
          minimum_composite:
            $ref: '#/components/schemas/MinimumCompositePrice'
          package:
            $ref: '#/components/schemas/PackagePrice'
          package_with_allocation:
            $ref: '#/components/schemas/PackageWithAllocationPrice'
          percent:
            $ref: '#/components/schemas/PercentCompositePrice'
          scalable_matrix_with_tiered_pricing:
            $ref: '#/components/schemas/ScalableMatrixWithTieredPricingPrice'
          scalable_matrix_with_unit_pricing:
            $ref: '#/components/schemas/ScalableMatrixWithUnitPricingPrice'
          threshold_total_amount:
            $ref: '#/components/schemas/ThresholdTotalAmountPrice'
          tiered:
            $ref: '#/components/schemas/TieredPrice'
          tiered_package:
            $ref: '#/components/schemas/TieredPackagePrice'
          tiered_package_with_minimum:
            $ref: '#/components/schemas/TieredPackageWithMinimumPrice'
          tiered_with_minimum:
            $ref: '#/components/schemas/TieredWithMinimumPrice'
          tiered_with_proration:
            $ref: '#/components/schemas/TieredWithProrationPrice'
          unit:
            $ref: '#/components/schemas/UnitPrice'
          unit_with_percent:
            $ref: '#/components/schemas/UnitWithPercentPrice'
          unit_with_proration:
            $ref: '#/components/schemas/UnitWithProrationPrice'
    MonetaryUsageDiscountAdjustment:
      properties:
        id:
          type: string
          title: Id
        is_invoice_level:
          type: boolean
          title: Is Invoice Level
          description: >-
            True for adjustments that apply to an entire invoice, false for
            adjustments that apply to only one price.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this adjustment to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: The price IDs that this adjustment applies to.
          deprecated: true
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
          description: The reason for the adjustment.
        replaces_adjustment_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Adjustment Id
          description: >-
            The adjustment id this adjustment replaces. This adjustment will
            take the place of the replaced adjustment in plan version
            migrations.
        adjustment_type:
          type: string
          enum:
            - usage_discount
          title: Adjustment Type
        usage_discount:
          type: number
          title: Usage Discount
          description: >-
            The number of usage units by which to discount the price this
            adjustment applies to in a given billing period.
        amount:
          type: string
          title: Amount
          description: The value applied by an adjustment.
      type: object
      required:
        - id
        - is_invoice_level
        - filters
        - applies_to_price_ids
        - reason
        - replaces_adjustment_id
        - adjustment_type
        - usage_discount
        - amount
      title: MonetaryUsageDiscountAdjustment
    MonetaryAmountDiscountAdjustment:
      properties:
        id:
          type: string
          title: Id
        is_invoice_level:
          type: boolean
          title: Is Invoice Level
          description: >-
            True for adjustments that apply to an entire invoice, false for
            adjustments that apply to only one price.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this adjustment to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: The price IDs that this adjustment applies to.
          deprecated: true
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
          description: The reason for the adjustment.
        replaces_adjustment_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Adjustment Id
          description: >-
            The adjustment id this adjustment replaces. This adjustment will
            take the place of the replaced adjustment in plan version
            migrations.
        adjustment_type:
          type: string
          enum:
            - amount_discount
          title: Adjustment Type
        amount_discount:
          type: string
          title: Amount Discount
          description: >-
            The amount by which to discount the prices this adjustment applies
            to in a given billing period.
        amount:
          type: string
          title: Amount
          description: The value applied by an adjustment.
      type: object
      required:
        - id
        - is_invoice_level
        - filters
        - applies_to_price_ids
        - reason
        - replaces_adjustment_id
        - adjustment_type
        - amount_discount
        - amount
      title: MonetaryAmountDiscountAdjustment
    MonetaryPercentageDiscountAdjustment:
      properties:
        id:
          type: string
          title: Id
        is_invoice_level:
          type: boolean
          title: Is Invoice Level
          description: >-
            True for adjustments that apply to an entire invoice, false for
            adjustments that apply to only one price.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this adjustment to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: The price IDs that this adjustment applies to.
          deprecated: true
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
          description: The reason for the adjustment.
        replaces_adjustment_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Adjustment Id
          description: >-
            The adjustment id this adjustment replaces. This adjustment will
            take the place of the replaced adjustment in plan version
            migrations.
        adjustment_type:
          type: string
          enum:
            - percentage_discount
          title: Adjustment Type
        percentage_discount:
          type: number
          maximum: 1
          minimum: 0
          title: Percentage Discount
          description: >-
            The percentage (as a value between 0 and 1) by which to discount the
            price intervals this adjustment applies to in a given billing
            period.
        amount:
          type: string
          title: Amount
          description: The value applied by an adjustment.
      type: object
      required:
        - id
        - is_invoice_level
        - filters
        - applies_to_price_ids
        - reason
        - replaces_adjustment_id
        - adjustment_type
        - percentage_discount
        - amount
      title: MonetaryPercentageDiscountAdjustment
    MonetaryMinimumAdjustment:
      properties:
        id:
          type: string
          title: Id
        is_invoice_level:
          type: boolean
          title: Is Invoice Level
          description: >-
            True for adjustments that apply to an entire invoice, false for
            adjustments that apply to only one price.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this adjustment to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: The price IDs that this adjustment applies to.
          deprecated: true
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
          description: The reason for the adjustment.
        replaces_adjustment_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Adjustment Id
          description: >-
            The adjustment id this adjustment replaces. This adjustment will
            take the place of the replaced adjustment in plan version
            migrations.
        adjustment_type:
          type: string
          enum:
            - minimum
          title: Adjustment Type
        minimum_amount:
          type: string
          title: Minimum Amount
          description: >-
            The minimum amount to charge in a given billing period for the
            prices this adjustment applies to.
        item_id:
          type: string
          title: Item Id
          description: The item ID that revenue from this minimum will be attributed to.
        amount:
          type: string
          title: Amount
          description: The value applied by an adjustment.
      type: object
      required:
        - id
        - is_invoice_level
        - filters
        - applies_to_price_ids
        - reason
        - replaces_adjustment_id
        - adjustment_type
        - minimum_amount
        - item_id
        - amount
      title: MonetaryMinimumAdjustment
    MonetaryMaximumAdjustment:
      properties:
        id:
          type: string
          title: Id
        is_invoice_level:
          type: boolean
          title: Is Invoice Level
          description: >-
            True for adjustments that apply to an entire invoice, false for
            adjustments that apply to only one price.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: The filters that determine which prices to apply this adjustment to.
        applies_to_price_ids:
          items:
            type: string
          type: array
          title: Applies To Price Ids
          description: The price IDs that this adjustment applies to.
          deprecated: true
        reason:
          oneOf:
            - type: string
            - type: 'null'
          title: Reason
          description: The reason for the adjustment.
        replaces_adjustment_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Adjustment Id
          description: >-
            The adjustment id this adjustment replaces. This adjustment will
            take the place of the replaced adjustment in plan version
            migrations.
        adjustment_type:
          type: string
          enum:
            - maximum
          title: Adjustment Type
        maximum_amount:
          type: string
          title: Maximum Amount
          description: >-
            The maximum amount to charge in a given billing period for the
            prices this adjustment applies to.
        amount:
          type: string
          title: Amount
          description: The value applied by an adjustment.
      type: object
      required:
        - id
        - is_invoice_level
        - filters
        - applies_to_price_ids
        - reason
        - replaces_adjustment_id
        - adjustment_type
        - maximum_amount
        - amount
      title: MonetaryMaximumAdjustment
    MatrixSubLineItem:
      properties:
        amount:
          type: string
          title: Amount
          description: The total amount for this sub line item.
          examples:
            - '9.00'
        name:
          type: string
          title: Name
          examples:
            - Tier One
        quantity:
          type: number
          title: Quantity
          examples:
            - 5
        grouping:
          oneOf:
            - $ref: '#/components/schemas/SubLineItemGrouping'
            - type: 'null'
        type:
          type: string
          enum:
            - matrix
          title: Type
        scaled_quantity:
          oneOf:
            - type: number
            - type: 'null'
          title: Scaled Quantity
          description: >-
            The scaled quantity for this line item for specific pricing
            structures
        matrix_config:
          $ref: '#/components/schemas/SubLineItemMatrixConfig'
      type: object
      required:
        - amount
        - name
        - quantity
        - grouping
        - type
        - matrix_config
      title: MatrixSubLineItem
    TierSubLineItem:
      properties:
        amount:
          type: string
          title: Amount
          description: The total amount for this sub line item.
          examples:
            - '9.00'
        name:
          type: string
          title: Name
          examples:
            - Tier One
        quantity:
          type: number
          title: Quantity
          examples:
            - 5
        grouping:
          oneOf:
            - $ref: '#/components/schemas/SubLineItemGrouping'
            - type: 'null'
        type:
          type: string
          enum:
            - tier
          title: Type
        tier_config:
          $ref: '#/components/schemas/TierSubLineItemTierConfig'
      type: object
      required:
        - amount
        - name
        - quantity
        - grouping
        - type
        - tier_config
      title: TierSubLineItem
    OtherSubLineItem:
      properties:
        amount:
          type: string
          title: Amount
          description: The total amount for this sub line item.
          examples:
            - '9.00'
        name:
          type: string
          title: Name
          examples:
            - Tier One
        quantity:
          type: number
          title: Quantity
          examples:
            - 5
        grouping:
          oneOf:
            - $ref: '#/components/schemas/SubLineItemGrouping'
            - type: 'null'
        type:
          type: string
          enum:
            - '''null'''
          title: Type
      type: object
      required:
        - amount
        - name
        - quantity
        - grouping
        - type
      title: OtherSubLineItem
    UnitPrice:
      properties:
        model_type:
          type: string
          enum:
            - unit
          title: Model Type
          description: The pricing model type
        unit_config:
          $ref: '#/components/schemas/UnitConfig'
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        external_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Price Id
        replaces_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Price Id
          description: >-
            The price id this price replaces. This price will take the place of
            the replaced price in plan version migrations.
        price_type:
          type: string
          enum:
            - usage_price
            - fixed_price
            - composite_price
          title: Price Type
        created_at:
          type: string
          format: date-time
          title: Created At
        cadence:
          type: string
          enum:
            - one_time
            - monthly
            - quarterly
            - semi_annual
            - annual
            - custom
          title: Cadence
        billing_mode:
          type: string
          enum:
            - in_advance
            - in_arrear
          title: Billing Mode
        billing_cycle_configuration:
          $ref: '#/components/schemas/BillingCycleConfiguration'
        invoicing_cycle_configuration:
          oneOf:
            - $ref: '#/components/schemas/BillingCycleConfiguration'
            - type: 'null'
        billable_metric:
          oneOf:
            - $ref: '#/components/schemas/BillableMetricTiny'
            - type: 'null'
        dimensional_price_configuration:
          oneOf:
            - $ref: '#/components/schemas/DimensionalPriceConfiguration'
            - type: 'null'
        fixed_price_quantity:
          oneOf:
            - type: number
            - type: 'null'
          title: Fixed Price Quantity
        plan_phase_order:
          oneOf:
            - type: integer
            - type: 'null'
          title: Plan Phase Order
        currency:
          type: string
          title: Currency
        conversion_rate:
          oneOf:
            - type: number
            - type: 'null'
          title: Conversion Rate
        conversion_rate_config:
          oneOf:
            - $ref: '#/components/schemas/ConversionRateConfig'
            - type: 'null'
        item:
          $ref: '#/components/schemas/ItemSlim'
        credit_allocation:
          oneOf:
            - $ref: '#/components/schemas/Allocation'
            - type: 'null'
        composite_price_filters:
          oneOf:
            - items:
                $ref: '#/components/schemas/PriceFilter'
              type: array
            - type: 'null'
          title: Composite Price Filters
        invoice_grouping_key:
          oneOf:
            - type: string
            - type: 'null'
          title: Invoice Grouping Key
        license_type:
          oneOf:
            - $ref: '#/components/schemas/LicenseType'
            - type: 'null'
        discount:
          oneOf:
            - $ref: '#/components/schemas/Discount'
            - type: 'null'
          deprecated: true
        minimum:
          oneOf:
            - $ref: '#/components/schemas/Minimum'
            - type: 'null'
          deprecated: true
        minimum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Minimum Amount
          deprecated: true
        maximum:
          oneOf:
            - $ref: '#/components/schemas/Maximum'
            - type: 'null'
          deprecated: true
        maximum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Maximum Amount
          deprecated: true
      type: object
      required:
        - model_type
        - unit_config
        - metadata
        - id
        - name
        - external_price_id
        - replaces_price_id
        - price_type
        - created_at
        - cadence
        - billing_mode
        - billing_cycle_configuration
        - invoicing_cycle_configuration
        - billable_metric
        - fixed_price_quantity
        - plan_phase_order
        - currency
        - conversion_rate
        - conversion_rate_config
        - item
        - credit_allocation
        - composite_price_filters
        - invoice_grouping_key
        - discount
        - minimum
        - minimum_amount
        - maximum
        - maximum_amount
      title: UnitPrice
    TieredPrice:
      properties:
        model_type:
          type: string
          enum:
            - tiered
          title: Model Type
          description: The pricing model type
        tiered_config:
          $ref: '#/components/schemas/TieredConfig'
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        external_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Price Id
        replaces_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Replaces Price Id
          description: >-
            The price id this price replaces. This price will take the place of
            the replaced price in plan version migrations.
        price_type:
          type: string
          enum:
            - usage_price
            - fixed_price
            - composite_price
          title: Price Type
        created_at:
          type: string
          format: date-time
          title: Created At
        cadence:
          type: string
          enum:
            - one_time
            - monthly
            - quarterly
            - semi_annual
            - annual
            - custom
          title: Cadence
        billing_mode:
          type: string
          enum:
            - in_advance
            - in_arrear
          title: Billing Mode
        billing_cycle_configuration:
          $ref: '#/components/schemas/BillingCycleConfiguration'
        invoicing_cycle_configuration:
          oneOf:
            - $ref: '#/components/schemas/BillingCycleConfiguration'
            - type: 'null'
        billable_metric:
          oneOf:
            - $ref: '#/components/schemas/BillableMetricTiny'
            - type: 'null'
        dimensional_price_configuration:
          oneOf:
            - $ref: '#/components/schemas/DimensionalPriceConfiguration'
            - type: 'null'
        fixed_price_quantity:
          oneOf:
            - type: number
            - type: 'null'
          title: Fixed Price Quantity
        plan_phase_order:
          oneOf:
            - type: integer
            - type: 'null'
          title: Plan Phase Order
        currency:
          type: string
          title: Currency
        conversion_rate:
          oneOf:
            - type: number
            - type: 'null'
          title: Conversion Rate
        conversion_rate_config:
          oneOf:
            - $ref: '#/components/schemas/ConversionRateConfig'
            - type: 'null'
        item:
          $ref: '#/components/schemas/ItemSlim'
        credit_allocation:
          oneOf:
            - $ref: '#/components/schemas/Allocation'
            - type: 'null'
        composite_price_filters:
          oneOf:
            - items:
                $ref: '#/components/schemas/PriceFilter'
              type: array
            - type: 'null'
          title: Composite Price Filters
        invoice_grouping_key:
          oneOf:
            - type: string
            - type: 'null'
          title: Invoice Grouping Key
        license_type:
          oneOf:
            - $ref: '#/components/schemas/LicenseType'
            - type: 'null'
        discount:
          oneOf:
            - $ref: '#/components/schemas/Discount'
            - type: 'null'
          deprecated: true
        minimum:
          oneOf:
            - $ref: '#/components/schemas/Minimum'
            - type: 'null'
          deprecated: true
        minimum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Minimum Amount
          deprecated: true
        maximum:
          oneOf:
            - $ref: '#/components/schemas/Maximum'
            - type: 'null'
          deprecated: true
        maximum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Maximum Amount
          deprecated: true
      type: object
      required:
        - model_type
        - tiered_config
        - metadata
        - id
        - name
        - external_price_id
        - replaces_price_id
        - price_type
        - created_at
        - cadence
        - billing_mode
        - billing_cycle_configuration
        - invoicing_cycle_configuration
        - billable_metric
        - fixed_price_quantity
        - plan_phase_order
        - currency
        - conversion_rate
        - conversion_rate_config
        - item
        - credit_allocation
        - composite_price_filters
        - invoice_grouping_key
        - discount
        - minimum
        - minimum_amount
        - maximum
        - maximum_amount
      title: TieredPrice
    BulkPrice:
      properties:
        model_type:
          type: string
          enum:
            - bulk
          title: Model Type
          description: The pricing model type
        bulk_config:
          $ref: '#/components/schemas/BulkConfig'
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
[...]
